import { SvelteComponent, init, safe_not_equal, element, append, attr, insert, noop, detach, binding_callbacks } from 'svelte/internal';
import { onMount, onDestroy } from 'svelte';
import { bind, clear } from 'size-sensor';

/* src/index.svelte generated by Svelte v3.6.6 */

function add_css() {
	var style = element("style");
	style.id = 'svelte-27zvya-style';
	style.textContent = ".root.svelte-27zvya{height:300px}";
	append(document.head, style);
}

function create_fragment(ctx) {
	var div;

	return {
		c() {
			div = element("div");
			attr(div, "class", "" + ctx.rootClassName + " svelte-27zvya");
		},

		m(target, anchor) {
			insert(target, div, anchor);
			ctx.div_binding(div);
		},

		p(changed, ctx) {
			if (changed.rootClassName) {
				attr(div, "class", "" + ctx.rootClassName + " svelte-27zvya");
			}
		},

		i: noop,
		o: noop,

		d(detaching) {
			if (detaching) {
				detach(div);
			}

			ctx.div_binding(null);
		}
	};
}

function instance_1($$self, $$props, $$invalidate) {
	

  // echarts lib
  let { echarts, option, className = '', notMerge = false, lazyUpdate = false, theme = null, onChartReady = () => {} } = $$props;
  // the echarts loading option config
  // See http://echarts.baidu.com/api.html#echartsInstance.showLoading
  let { loadingOption = null, loading = false, events = {}, opts = {} } = $$props;

  let rootElement;
  let instance;

  onMount(() => {
    instance = echarts.init(rootElement, theme, opts);
    instance.setOption(option, notMerge, lazyUpdate);
    if (loading) {
      instance.showLoading(loadingOption);
    }
    Object.entries(events).forEach(([name, cb]) => {
      instance.on(name, cb);
    });
    onChartReady();
    bind(rootElement, () => instance.resize());
  });

  onDestroy(() => {
    clear(rootElement);
    instance.dispose(rootElement);
  });

	function div_binding($$value) {
		binding_callbacks[$$value ? 'unshift' : 'push'](() => {
			$$invalidate('rootElement', rootElement = $$value);
		});
	}

	$$self.$set = $$props => {
		if ('echarts' in $$props) $$invalidate('echarts', echarts = $$props.echarts);
		if ('option' in $$props) $$invalidate('option', option = $$props.option);
		if ('className' in $$props) $$invalidate('className', className = $$props.className);
		if ('notMerge' in $$props) $$invalidate('notMerge', notMerge = $$props.notMerge);
		if ('lazyUpdate' in $$props) $$invalidate('lazyUpdate', lazyUpdate = $$props.lazyUpdate);
		if ('theme' in $$props) $$invalidate('theme', theme = $$props.theme);
		if ('onChartReady' in $$props) $$invalidate('onChartReady', onChartReady = $$props.onChartReady);
		if ('loadingOption' in $$props) $$invalidate('loadingOption', loadingOption = $$props.loadingOption);
		if ('loading' in $$props) $$invalidate('loading', loading = $$props.loading);
		if ('events' in $$props) $$invalidate('events', events = $$props.events);
		if ('opts' in $$props) $$invalidate('opts', opts = $$props.opts);
	};

	let rootClassName;

	$$self.$$.update = ($$dirty = { className: 1 }) => {
		if ($$dirty.className) { $$invalidate('rootClassName', rootClassName = ['root', className].join(' ')); }
	};

	return {
		echarts,
		option,
		className,
		notMerge,
		lazyUpdate,
		theme,
		onChartReady,
		loadingOption,
		loading,
		events,
		opts,
		rootElement,
		rootClassName,
		div_binding
	};
}

class Index extends SvelteComponent {
	constructor(options) {
		super();
		if (!document.getElementById("svelte-27zvya-style")) add_css();
		init(this, options, instance_1, create_fragment, safe_not_equal, ["echarts", "option", "className", "notMerge", "lazyUpdate", "theme", "onChartReady", "loadingOption", "loading", "events", "opts"]);
	}
}

export default Index;
